////////////////////////////////////////////////////////////////////////////////
//      _    _  ____            ____    // Main.pas: unit Main, TMainForm     //
//     / \  | |/ ___| ___ _ __ |___ \   //------------------------------------//
//    / _ \ | | |  _ / _ \ '_ \  __) |  // Hauptfensterunit                   //
//   / ___ \| | |_| |  __/ | | |/ __/   //                                    //
//  /_/   \_\_|\____|\___|_| |_|_____|  //                                    //
//                                      //                                    //
////////////////////////////////////////////////////////////////////////////////
unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Menus, ExtCtrls, ComCtrls, Buttons, ShellAPI;

type
  TMainForm = class(TForm)
    // 141(!) Controls
    PageThing: TPageControl;
    PCommon: TTabSheet;
    PImages: TTabSheet;
    PLogo: TPanel;
    CCategory: TComboBox;
    CImages: TListBox;
    PLog: TTabSheet;
    PHelp: TTabSheet;
    BImageMenu: TBitBtn;
    LCategory: TLabel;
    BEditCategories: TBitBtn;
    PCatEdit: TPanel;
    EComment: TEdit;
    LComment: TLabel;
    BImageUp: TBitBtn;
    BImageDown: TBitBtn;
    CatList: TListBox;
    BCatUp: TBitBtn;
    BCatDown: TBitBtn;
    BCatRemove: TBitBtn;
    BCatAdd: TBitBtn;
    BCatClose: TBitBtn;
    Logo: TPaintBox;
    BCatRename: TBitBtn;
    RotationMenu: TPopupMenu;
    MRotate0: TMenuItem;
    MRotate90CW: TMenuItem;
    MRotate90CCW: TMenuItem;
    MRotate180: TMenuItem;
    ImageMenu: TPopupMenu;
    MSortByName: TMenuItem;
    MSortByDate: TMenuItem;
    MSortByEXIF: TMenuItem;
    LogBox: TListBox;
    BAbortOp: TBitBtn;
    DestDirDialog: TSaveDialog;
    OptionsScoller: TScrollBox;
    PCommonSettings: TPanel;
    LDestDir: TLabel;
    LTitle: TLabel;
    LCommonSettings: TLabel;
    BCommonSettings: TBevel;
    ETitle: TEdit;
    EDestDir: TEdit;
    BDestDir: TButton;
    PPreviewImageSettings: TPanel;
    LPreviewImageSettings: TLabel;
    BPreviewImageSettings: TBevel;
    LPSize: TLabel;
    LPSizeX: TLabel;
    LPQuality: TLabel;
    EPSizeX: TEdit;
    EPSizeY: TEdit;
    CPQuadratic: TCheckBox;
    CPProgressive: TCheckBox;
    EPQuality: TEdit;
    CPSizeX: TUpDown;
    CPSizeY: TUpDown;
    CPQuality: TUpDown;
    PThumbnailImageSettings: TPanel;
    LThumbnailImageSettings: TLabel;
    BThumbnailImageSettings: TBevel;
    LTSize: TLabel;
    LTSizeX: TLabel;
    LTQuality: TLabel;
    ETSizeX: TEdit;
    ETSizeY: TEdit;
    CTQuadratic: TCheckBox;
    CTProgressive: TCheckBox;
    ETQuality: TEdit;
    CTSizeX: TUpDown;
    CTSizeY: TUpDown;
    CTQuality: TUpDown;
    PFileNameSettings: TPanel;
    BFileNameSettings: TBevel;
    LFileNameSettings: TLabel;
    LfnPreview: TLabel;
    EfnPreview: TEdit;
    CdirPreview: TCheckBox;
    EdirPreview: TEdit;
    EdirThumbnails: TEdit;
    CdirThumbnails: TCheckBox;
    EfnThumbnails: TEdit;
    LfnThumbnails: TLabel;
    LfnHTML: TLabel;
    EfnHTML: TEdit;
    LfnInfo: TLabel;
    EfnInfo: TEdit;
    LfnIndex: TLabel;
    EfnIndex: TEdit;
    LDigits: TLabel;
    EDigits: TEdit;
    CDigits: TUpDown;
    POutputOptions: TPanel;
    LOutputOptions: TLabel;
    BOutputOptions: TBevel;
    LOutputHTML: TLabel;
    COutputHTML: TComboBox;
    LThumbsPerLine: TLabel;
    EThumbsPerLine: TEdit;
    CThumbsPerLine: TUpDown;
    LUncat: TLabel;
    CUncatIgnore: TRadioButton;
    CUncatAtStart: TRadioButton;
    CUncatAtEnd: TRadioButton;
    BGo: TBitBtn;
    N1: TMenuItem;
    MShowPreview: TMenuItem;
    MShowThumbnail: TMenuItem;
    CEnableFrame: TCheckBox;
    EFrameSize: TEdit;
    CFrameSize: TUpDown;
    LFrameSize: TLabel;
    PPreprocess: TPanel;
    LPreprocess: TLabel;
    BPreprocess: TBevel;
    CEnableEqualize: TCheckBox;
    CMedianFilter: TCheckBox;
    CEqualizeGray: TRadioButton;
    CEqualizeRGB: TRadioButton;
    EEqualizeStrength: TEdit;
    CEqualizeStrength: TUpDown;
    LEqualizeStrength: TLabel;
    Crmrf: TCheckBox;
    CFullWidth: TCheckBox;
    CVerbose: TCheckBox;
    BLoadProject: TBitBtn;
    BSaveProject: TBitBtn;
    DSaveProject: TSaveDialog;
    DLoadProject: TOpenDialog;
    LAlGen2: TLabel;
    LDescription1: TLabel;
    LDescription2: TLabel;
    LMailMe: TSpeedButton;
    BHelp: TBitBtn;
    Tips: TMemo;
    PTips: TPanel;
    N2: TMenuItem;
    MReset: TMenuItem;
    DAddImages: TOpenDialog;
    MAddImages: TMenuItem;
    // 48 Event-Handler
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure CCategoryChange(Sender: TObject);
    procedure CImagesDrawItem(Control: TWinControl; BoxIndex: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure CImagesMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure MRotateClick(Sender: TObject);
    procedure BEditCategoriesClick(Sender: TObject);
    procedure BCatCloseClick(Sender: TObject);
    procedure LogoPaint(Sender: TObject);
    procedure BCatUpClick(Sender: TObject);
    procedure BCatDownClick(Sender: TObject);
    procedure BCatRenameClick(Sender: TObject);
    procedure BCatRemoveClick(Sender: TObject);
    procedure BCatAddClick(Sender: TObject);
    procedure CImagesKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure CImagesClick(Sender: TObject);
    procedure ECommentKeyPress(Sender: TObject; var Key: Char);
    procedure ECommentKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure BImageUpClick(Sender: TObject);
    procedure BImageDownClick(Sender: TObject);
    procedure CImagesKeyPress(Sender: TObject; var Key: Char);
    procedure MSortByNameClick(Sender: TObject);
    procedure BImageMenuClick(Sender: TObject);
    procedure MSortByDateClick(Sender: TObject);
    procedure MSortByEXIFClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure LogBoxDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure BAbortOpClick(Sender: TObject);
    procedure PageThingChanging(Sender: TObject; var AllowChange: Boolean);
    procedure CPQuadraticClick(Sender: TObject);
    procedure CTQuadraticClick(Sender: TObject);
    procedure CPSizeXClick(Sender: TObject; Button: TUDBtnType);
    procedure CTSizeXClick(Sender: TObject; Button: TUDBtnType);
    procedure BDestDirClick(Sender: TObject);
    procedure CdirPreviewClick(Sender: TObject);
    procedure CdirThumbnailsClick(Sender: TObject);
    procedure COutputHTMLChange(Sender: TObject);
    procedure MShowPreviewClick(Sender: TObject);
    procedure CEnableFrameClick(Sender: TObject);
    procedure CEnableEqualizeClick(Sender: TObject);
    procedure BGoClick(Sender: TObject);
    procedure BSaveProjectClick(Sender: TObject);
    procedure BLoadProjectClick(Sender: TObject);
    procedure LMailMeClick(Sender: TObject);
    procedure BHelpClick(Sender: TObject);
    procedure MResetClick(Sender: TObject);
    procedure MAddImagesClick(Sender: TObject);
  private
    { Private declarations }
    LCBChecked,LCBUnchecked,ArrowBlack,ArrowWhite:TBitmap;
               // 4 kleine Bitmaps: Hkchen und Drop-Down-Pfeil wei und schwarz
    BarAlGen,BarGradient,BarPictures:TBitmap;  // 3 groe Bitmaps fr den Balken
    CategoriesChanged:boolean;
                              // Flag, ob im Kategorieneditor was gendert wurde
    EComment_Image:string;
           // PathName des Bildes, dessen Beschreibung gerade im Edit-Feld steht
    RecentImage:string;  // PathName des Bildes, auf das der Cursor nach einer
                         // Bilderlistenoperation gesetzt werden soll (siehe
                         // SaveRecentImage/RestoreRecentImage)
    OpLock:boolean;  // Flag: wenn True, ist der Wechsel der Seite gesperrt
    CategoryPopup:TPopupMenu; // Kategorien-Popup-Men (wird dynamisch erstellt)
    procedure MCategoryClick(Sender: TObject);
                                     // Event-Handler des Kategorien-Popup-Mens
    procedure MNewCategoryClick(Sender: TObject);
                                     // Event-Handler des Kategorien-Popup-Mens
    procedure FormDropFiles(var msg:TMessage); message WM_DROPFILES;
                                          // Event-Handler fr abgelegte Dateien
    procedure AddFileList(FileList:TStrings);  // Dateien hinzufgen
    procedure SaveRecentImage;  // PathName des nchsten nicht-markierten Bildes
                                // speichern
    procedure RestoreRecentImage;  // Bild mit dem gemerkten Name in CImages
                                   // selektieren
    procedure SelectImages;  // CImages.Selected[] auf Data[].Selected kopieren
    procedure ApplySelection;  // Data[].Selected -> CImages.Selected[]
    procedure ApplyAndAdvance(Direction:integer);
      // Beschreibung eines Bildes bernehmen und zum nchsten Bild weiterrcken
  public
    { Public declarations }
    procedure SelectOp(ReturnToTab:TTabSheet);
      // Operation einberufen:
      //   ReturnToTab=nil -> Operation starten, OpLock ein, PLog aktivieren
      //   ansonsten -> Operation beendet, OpLock aus, gegebenes Tab aktivieren
  end;

var
  MainForm: TMainForm;

var AbortOp:boolean;  // Flag, ob die aktuelle Operation abgebrochen werden soll
    MyVersion:string;  // Versionsnummer :)

procedure Log(const msg:string);  // Zeile zum Logbuch hinzufgen

implementation
uses Datacore, Acquire, Core, Preview, Process, LoadSave;

{$R *.dfm}
{$R check.res}
{$R a2bar.res}

////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////// Initialisierung
////////////////////////////////////////////////////////////////////////////////

///// LoadBitmapResource: erstellt eine TBitmap-Instanz aus einer Resource
function LoadBitmapResource(const ResName:string; Transparent:boolean):TBitmap;
begin
  Result:=TBitmap.Create;
  Result.LoadFromResourceName(HInstance,ResName);
  if Transparent then begin
    Result.Transparent:=true;
    Result.TransparentMode:=tmAuto;
  end;
end;


///// GetMyVersion: eigene Versionsnummer ermitteln
function GetMyVersion:string;
var Dummy:cardinal;
    VerInfoSize:integer;
    VerData,VerInfo:pointer;
    Info:^VS_FIXEDFILEINFO;
begin
  Result:='';
  VerInfoSize:=GetFileVersionInfoSize(PChar(ParamStr(0)),Dummy);
  // Gre der Versionsinfo ermitteln und ggf. abbrechen
  if VerInfoSize<=0 then exit;
  GetMem(VerData,VerInfoSize);
  // Versionsinfo ermitteln, "Root-Block" extrahieren
  if GetFileVersionInfo(PChar(ParamStr(0)),Dummy,VerInfoSize,VerData) AND
     VerQueryValue(VerData,'\',VerInfo,Dummy) then begin
    Info:=VerInfo;
    with Info^ do begin  // Versionsnummer als String zusammenbauen
      Result:=
        IntToStr(dwFileVersionMS SHR 16)+'.'+
        IntToStr(dwFileVersionMS AND $FFFF)+'.'+
        IntToStr(dwFileVersionLS SHR 16)+'.'+
        IntToStr(dwFileVersionLS AND $FFFF);
    end;
  end;
  FreeMem(VerData,VerInfoSize);
end;


///// MainForm.OnCreate: Initialisierung
procedure TMainForm.FormCreate(Sender: TObject);
begin
//AllocConsole;  // fr Debugging immer wieder praktisch
  // diverse Resource-Bitmaps laden
  LCBChecked:=LoadBitmapResource('LCB_CHECKED',true);
  LCBUnchecked:=LoadBitmapResource('LCB_UNCHECKED',true);
  ArrowBlack:=LoadBitmapResource('ARROW_BLACK',true);
  ArrowWhite:=LoadBitmapResource('ARROW_WHITE',true);
  BarAlGen:=LoadBitmapResource('BAR_ALGEN',false);
  BarGradient:=LoadBitmapResource('BAR_GRADIENT',false);
  BarPictures:=LoadBitmapResource('BAR_PICTURES',false);
  {$I Tips.inc}  // Tips in die Tips-Box laden (so umstndlich, weil der
                 // Delphi-Editor sonst die Zeilen vorher umbricht :( )
  // Bilderliste initialisieren
  Data:=TImageManager.Create;
  Data.CategoriesToStrings(-1,CCategory.Items);
  EComment_Image:='';
  OpLock:=false;
  CategoryPopup:=nil;
  CImages.ItemHeight:=ThumbnailHeight;
  CCategory.ItemIndex:=0;
  CCategoryChange(nil);
  // Kosmetik
  DecimalSeparator:='.'; ThousandSeparator:=#0;
  Logo.ControlStyle:=Logo.ControlStyle+[csOpaque];  // gegen Flimmern
  // Versionsnummer bestimmen, Begrungstext loggen
  MyVersion:=GetMyVersion;
  if MyVersion='' then Log('/Willkommen in AlGen2')
                  else Log('/Willkommen in AlGen2 Version '+MyVersion);
  Log('');
end;


///// MainForm.OnDestroy: Deinitialisierung
procedure TMainForm.FormDestroy(Sender: TObject);
begin
  Data.Free;  // nicht ntig, aber ich programmiere ja sauber *hstel*
end;


////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////// Verschiedenes
////////////////////////////////////////////////////////////////////////////////

///// Logo.OnPaint: Logo in den Sidebar zeichnen
procedure TMainForm.LogoPaint(Sender: TObject);
var MaxY,Y:integer;
begin
  // MaxY = Y-Koordinate, an der der AlGen2-Text erscheinen mu
  MaxY:=Logo.Height-BarAlGen.Height;
  if MaxY<BarPictures.Height then
    // wenn MaxY kleiner als Hhe des Bildteils mit den Fotos, dann nur diesen
    // nach oben hinausgeschoben zeichnen
    Logo.Canvas.Draw(0,MaxY-BarPictures.Height,BarPictures)
  else begin
    // ansonsten Fotocollage nach Y=0 zeichnen ...
    Logo.Canvas.Draw(0,0,BarPictures);
    // ... und nach unten je nach Bedarf mit dem Farbverlauf ausfllen
    Y:=BarPictures.Height;
    while (Y<MaxY) do begin
      Logo.Canvas.Draw(0,Y,BarGradient);
      inc(Y,BarGradient.Height);
    end;
  end;
  // schlielich den AlGen2-Textausschnitt zeichnen
  Logo.Canvas.Draw(0,MaxY,BarAlGen);
end;


///// LMailMe.OnClick: Mail an mich schreiben lassen
procedure TMainForm.LMailMeClick(Sender: TObject);
begin
  ShellExecute(Handle,'open','mailto:martin.fiedler@gmx.net?subject=AlGen2',
               nil,nil,SW_SHOW);
end;


///// BHelp.OnClick: Hilfedatei ffnen
procedure TMainForm.BHelpClick(Sender: TObject);
var MyDir:string;
begin
  MyDir:=ExcludeTrailingPathDelimiter(ExtractFilePath(
         ExpandUNCFileName(ParamStr(0))));
  if ShellExecute(Handle,'open',PChar(MyDir+'\AlGen2.htm'),nil,PChar(MyDir),SW_SHOW)>32 then exit;
  MessageDlg('Sorry, die Hilfe konnte leider nicht aufgerufen werden.',
             mtError,[mbOK],0);
end;


///// SelectImages: setzt Data[].Selection entsprechend CImages.Selected[]
procedure TMainForm.SelectImages;
var BoxIndex:integer;
begin
  Data.UnselectAll;
  for BoxIndex:=(CImages.Items.Count-1) downto 0 do
    if CImages.Selected[BoxIndex] then
      Data.Select(s2i(CImages.Items[BoxIndex]));
end;


///// ApplySelection: setzt CImages.Selected[] entsprechend Data[].Selection
procedure TMainForm.ApplySelection;
var BoxIndex,Index:integer;
begin
  CImages.ClearSelection;
  for BoxIndex:=(CImages.Items.Count-1) downto 0 do begin
    Index:=s2i(CImages.Items[BoxIndex]);
    if Data[Index]^.Selected then
      CImages.Selected[BoxIndex]:=true;
  end;
end;


////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////// Bilderliste
////////////////////////////////////////////////////////////////////////////////

///// CCategory.OnChange: Kategorie wechseln und CImages aktualisieren
procedure TMainForm.CCategoryChange(Sender: TObject);
begin
  Data.SelectedCategory:=CCategory.ItemIndex-1;
  Data.ImagesToStrings(CImages.Items);
end;


///// CImages.DrawItem: ein Element von CImages zeichnen
procedure TMainForm.CImagesDrawItem(Control: TWinControl; BoxIndex: Integer;
  Rect: TRect; State: TOwnerDrawState);
var Index:integer;
    Item:PImageRecord;
    Arrow:^TBitmap;
begin with CImages.Canvas do begin
  Index:=s2i(CImages.Items[BoxIndex]);  // Data[]-Index extrahieren
  Item:=Data[Index];  // Datenfeld extrahieren
  FillRect(Rect);
  // Thumbnail
  try
    if Assigned(Item^.Thumbnail) then Draw(Rect.Left,Rect.Top,Item^.Thumbnail);
  except
  end;
  // Dateiname
  TextOut(Rect.Left+ThumbnailWidth+3,Rect.Top+17,Item^.PathName);
  // Bildinformationen
  TextOut(Rect.Left+ThumbnailWidth+3,Rect.Top+33,Item^.ImageInfo);
  // Kategorie
  if (odSelected in State) then Arrow:=@ArrowWhite else Arrow:=@ArrowBlack;
  Draw(Rect.Left+ThumbnailWidth+3,Rect.Top+54,Arrow^);
  TextOut(Rect.Left+ThumbnailWidth+12,Rect.Top+49,Data.Categories[Item^.Category]);
  // Drehung
  Draw(Rect.Right-89,Rect.Top+54,Arrow^);
  TextOut(Rect.Right-80,Rect.Top+49,Rotation[Item^.Rotation]);
  // Beschriftung
  TextOut(Rect.Left+ThumbnailWidth+3,Rect.Top+65,Item^.Comment);
  // Titelzeile
  Brush.Color:=$E0E0E0;
  FillRect(Classes.Rect(Rect.Left+ThumbnailWidth,Rect.Top,Rect.Right,Rect.Top+16));
  // Hkchen
  if Item^.Active then Draw(Rect.Left+ThumbnailWidth+2,Rect.Top+1,LCBChecked)
                  else Draw(Rect.Left+ThumbnailWidth+2,Rect.Top+1,LCBUnchecked);
  // kurzer Dateiname
  Font.Color:=0;
  TextOut(Rect.Left+ThumbnailWidth+18,Rect.Top+1,Item^.FileName);
  // Datum
  TextOut(Rect.Right-89,Rect.Top+1,Item^.DisplayDate);
end; end;


///// RotationMenu.MRotate*.OnClick: Drehung aller markierten Bilder ndern
procedure TMainForm.MRotateClick(Sender: TObject);
var BoxIndex,Index:integer;
begin
  for BoxIndex:=(CImages.Items.Count-1) downto 0 do
    if CImages.Selected[BoxIndex] then begin
      Index:=s2i(CImages.Items[BoxIndex]);
      Data[Index]^.Rotation:=TRotation((Sender as TComponent).Tag);
    end;
  CImages.Invalidate;  // CImages neu zeichnen
end;


///// CImages.MouseDown: diverse Steuerelemente innerhalb eines CImages-Eintrags
///// triggern
procedure TMainForm.CImagesMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var BoxIndex,Index,i:integer;
    Rect:TRect; Point:TPoint;
    Active:boolean;
    Item:TMenuItem;
begin
  inherited;  // Standardhandler aufrufen, damit schonmal was markiert wird
  BoxIndex:=CImages.ItemAtPos(Classes.Point(X,Y),true);
  if BoxIndex<0 then exit;
  Rect:=CImages.ItemRect(BoxIndex);  // Bereich des angeklickten Eintrags ...
  Index:=s2i(CImages.Items[BoxIndex]);  // ... und dessen Data[]-Index ermitteln
  //////////////////////// Hkchen ////////////////////////
  if (X>=Rect.Left+ThumbnailWidth) AND (Y>=Rect.Top) AND
     (X<Rect.Left+ThumbnailWidth+18) AND (Y<Rect.Top+16) then
  begin
    Active:=not(Data[Index]^.Active);
    // aktuellen Active-Status negieren und diesen auf alle markierten Elemente
    // bertragen
    for BoxIndex:=(CImages.Items.Count-1) downto 0 do
      if CImages.Selected[BoxIndex] then begin
        Index:=s2i(CImages.Items[BoxIndex]);
        Data[Index]^.Active:=Active;
      end;
    CImages.Invalidate;
  end else
  //////////////////////// Kategorien-Popup ////////////////////////
  if (X>=Rect.Left+ThumbnailWidth) AND (Y>=Rect.Top+48) AND
     (X<Rect.Left+ThumbnailWidth+12) AND (Y<Rect.Top+64) then
  begin
    // altes Popup entsorgen, neues erstellen
    if Assigned(CategoryPopup) then CategoryPopup.Free;
    CategoryPopup:=TPopupMenu.Create(Self);
    // die Items fr die Kategorien erzeugen
    for i:=0 to Data.CategoryCount do begin
      Item:=TMenuItem.Create(CategoryPopup);
      with Item do begin
        Caption:=Data.Categories[i];
        GroupIndex:=1;
        RadioItem:=true;
        if Data[Index]^.Category=i then Checked:=true;
        Tag:=i;
        OnClick:=MCategoryClick;
      end;
      CategoryPopup.Items.Add(Item);
    end;
    // Separator erzeugen
    Item:=TMenuItem.Create(CategoryPopup);
    Item.Caption:='-';
    CategoryPopup.Items.Add(Item);
    // "Neue Kategorie"-Eintrag erzeugen
    Item:=TMenuItem.Create(CategoryPopup);
    Item.Caption:='Neue Kategorie '#133;
    Item.OnClick:=MNewCategoryClick;
    CategoryPopup.Items.Add(Item);
    // Popup anzeigen
    Point:=CImages.ClientToScreen(Classes.Point(Rect.Left+ThumbnailWidth,Rect.Top+64));
    CategoryPopup.Popup(Point.X,Point.Y);
  end else
  //////////////////////// Rotations-Popup ////////////////////////
  if (X>=Rect.Right-91) AND (Y>=Rect.Top+48) AND
     (X<Rect.Right-80) AND (Y<Rect.Top+64) then
  begin
    // Drehung des aktuellen Bildes auf die Items des Rotations-Popup bertragen
    case Data[Index]^.Rotation of
      rot0:MRotate0.Checked:=true;
      rot90CW:MRotate90CW.Checked:=true;
      rot180:MRotate180.Checked:=true;
      rot90CCW:MRotate90CCW.Checked:=true;
    end;
    // Popup anzeigen
    Point:=CImages.ClientToScreen(Classes.Point(Rect.Right-91,Rect.Top+64));
    RotationMenu.Popup(Point.X,Point.Y);
  end;
end;


///// SaveRecentImage: legt den PathName des ersten nicht-markierten Bildes nach
///// der Markierung in RecentImage ab
procedure TMainForm.SaveRecentImage;
var BoxIndex,Index:integer;
    SelectedImageFound:boolean;
begin
  SelectedImageFound:=false;
  Index:=-1;
  for BoxIndex:=0 to (CImages.Items.Count-1) do
    if CImages.Selected[BoxIndex] then
      SelectedImageFound:=true
    else begin
      Index:=s2i(CImages.Items[BoxIndex]);
      if SelectedImageFound then break;
    end;
  if Index>=0 then RecentImage:=Data[Index]^.PathName
              else RecentImage:='';
end;


///// RestoreRecentImage: markiert das Bild, dessen PathName in RecentImage
///// abgelegt ist
procedure TMainForm.RestoreRecentImage;
var BoxIndex,Index:integer;
begin
  Index:=Data.FindImage(RecentImage);
  if Index<0 then exit;
  for BoxIndex:=(CImages.Items.Count-1) downto 0 do
    if Index=s2i(CImages.Items[BoxIndex]) then begin
      CImages.ItemIndex:=BoxIndex;
      exit;
    end;
end;


///// CategoryPopup.<Kategorie>.OnClick: alle markierten Bilder der gewhlten
///// Kategorie zuweisen
procedure TMainForm.MCategoryClick(Sender: TObject);
var BoxIndex,Index:integer;
begin
  for BoxIndex:=(CImages.Items.Count-1) downto 0 do
    if CImages.Selected[BoxIndex] then begin
      Index:=s2i(CImages.Items[BoxIndex]);
      Data[Index]^.Category:=(Sender as TComponent).Tag; // Tag ist praktisch :)
    end;
  // Liste neu sortieren, Markierung sinnvoll speichern
  SaveRecentImage;
  Data.Rehash;
  CCategoryChange(nil);
  RestoreRecentImage;
end;


///// CategoryPopup.<NeueKategorie>.OnClick: Name fr neue Kategorie eingeben
///// lassen, Kategorie anlegen, und alle markierten Bilder dieser zuweisen
procedure TMainForm.MNewCategoryClick(Sender: TObject);
var CatName:string;
    BoxIndex,Index:integer;
begin
  // InputBox fr den Kategorienname ffnen
  CatName:=InputBox('Kategorie hinzufgen','Name fr die neue Kategorie:','');
  if CatName='' then exit;
  // Kategorie anlegen
  Data.AddCategory(CatName);
  // Bilder zuweisen
  for BoxIndex:=(CImages.Items.Count-1) downto 0 do
    if CImages.Selected[BoxIndex] then begin
      Index:=s2i(CImages.Items[BoxIndex]);
      Data[Index]^.Category:=Data.CategoryCount;
    end;
  // Kategorien-Dropdown neu befllen, Liste neu sortieren,
  // dabei Markierung sinnvoll speichern
  SaveRecentImage;
  Index:=CCategory.ItemIndex;
  Data.Rehash;
  Data.CategoriesToStrings(-1,CCategory.Items);
  CCategory.ItemIndex:=Index;
  CCategoryChange(nil);
  RestoreRecentImage;
end;


///// CImages.OnKeyPress: [Strg]+[A] emulieren
procedure TMainForm.CImagesKeyPress(Sender: TObject; var Key: Char);
var BoxIndex:integer;
begin
  // Bei ^A alles markieren
  if Key=^A then
    for BoxIndex:=(CImages.Items.Count-1) downto 0 do
      CImages.Selected[BoxIndex]:=true;
end;


///// CImages.OnKeyDown: Tastenfunktionen [Entf] = Lschen und [Strg]+[Cursor]
///// = Verschieben fr die Bilderliste
procedure TMainForm.CImagesKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  // [Entf]: Bilder lschen, Liste neu sortieren, Markierung wiederherstellen
  if Key=VK_DELETE then begin
    SaveRecentImage;
    SelectImages;
    Data.RemoveSelectedImages;
    Data.Rehash;
    CCategoryChange(nil);
    RestoreRecentImage;
  end;
  // [Strg]+[Cursor]: entsprechende BImageUp/Down-OnClick-Events (s.u.) auslsen
  if (ssCtrl IN Shift) then begin
    if Key=VK_UP   then begin BImageUpClick(nil);   Key:=0; end else
    if Key=VK_DOWN then begin BImageDownClick(nil); Key:=0; end;
  end;
end;


///// BImageUp.OnClick: markierte Bilder nach oben bewegen
procedure TMainForm.BImageUpClick(Sender: TObject);
begin
  // Markierung zwecks spterer Wiederherstellung in Data[] vermerken;
  // die "Drecksarbeit" macht Data alleine
  SelectImages;
  Data.MoveSelectedUp;
  Data.Rehash;
  CCategoryChange(nil);
  ApplySelection;
end;


///// BImageDown.OnClick: markierte Bilder nach unten bewegen
procedure TMainForm.BImageDownClick(Sender: TObject);
begin
  // Markierung zwecks spterer Wiederherstellung in Data[] vermerken;
  // die "Drecksarbeit" macht Data alleine
  SelectImages;
  Data.MoveSelectedDown;
  Data.Rehash;
  CCategoryChange(nil);
  ApplySelection;
end;


///// CImages.OnClick: Beschreibung des angeklickten Bildes in den
///// Beschreibungseditor bernehmen
procedure TMainForm.CImagesClick(Sender: TObject);
var BoxIndex,Index:integer;
begin
  // erstmal Indexe bestimmen
  BoxIndex:=CImages.ItemIndex;
  if BoxIndex<0 then exit;
  Index:=s2i(CImages.Items[BoxIndex]);
  // Beschreibung bernehmen
  EComment.Text:=Data[Index]^.Comment;
  EComment_Image:=Data[Index]^.PathName;
  // Trick 17a,3: Wenn das Event wirklich von CImages ausgelst wurde (also
  // Sender<>nil), dann mu die Markierung nicht gesetzt werden, da in dem
  // Moment sowieso CImages und nicht EComment den Focus hat.
  // ApplyAndAdvance (s.u.) lst aber auch CImagesClick(nil) aus, und da hat
  // EComment den Focus, also wird die Beschreibung komplett markiert 
  if Assigned(Sender) then exit;
  EComment.SelStart:=0;
  EComment.SelLength:=16383;
end;


///// ApplyAndAdvance: Bildbeschreibung aus EComment in die Bilderliste ber-
///// tragen und zum nchsten (Direction=+1) bzw. vorigen (Direction=-1) Bild
///// weiterrcken
procedure TMainForm.ApplyAndAdvance(Direction:integer);
var BoxIndex,Index:integer;
begin
  // Bildindex finden
  Index:=Data.FindImage(EComment_Image);
  if Index<0 then exit;
  // Beschreibung bernehmen
  Data[Index]^.Comment:=EComment.Text;
  CImages.Invalidate;
  // BoxIndex finden
  BoxIndex:=CImages.ItemIndex;
  // wenn BoxIndex und Bildindex nicht passen, wird das Bild gerade nicht in
  // CImages angezeigt -> also nix tun
  if (BoxIndex<0) OR (s2i(CImages.Items[BoxIndex])<>Index) then exit;
  // Index ndern
  inc(BoxIndex,Direction);
  if (BoxIndex<0) then BoxIndex:=0;
  if (BoxIndex>=CImages.Items.Count) then BoxIndex:=CImages.Items.Count-1;
  // neues Bild in CImages selektieren
  CImages.ClearSelection;
  CImages.ItemIndex:=BoxIndex;
  CImages.Selected[BoxIndex]:=true;
  // CImages.OnClick faken (s.o.), um Beschreibung des neu ausgewhlten Bildes
  // wieder nach EComment zu laden
  CImagesClick(nil);
end;


///// EComment.OnKeyPress: [Enter] und [Esc] in EComment abfangen
procedure TMainForm.ECommentKeyPress(Sender: TObject; var Key: Char);
var Index:integer;
begin
  // [Enter]: Beschreibung bernehmen, nach unten weiter
  if Key=^M then ApplyAndAdvance(+1) else
  // [Esc]: Beschreibung wieder aus der Bilderliste zurckholen
  if Key=#27 then begin
    Index:=Data.FindImage(EComment_Image);
    if Index<0 then exit;
    EComment.Text:=Data[Index]^.Comment;
    EComment.SelStart:=0;
    EComment.SelLength:=16383;
  end;
end;


///// EComment.OnKeyDown: Cursortasten in EComment abfangen
procedure TMainForm.ECommentKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  // Cursor hoch = Beschreibung bernehmen, Cursor nach oben
  if Key=VK_UP then   begin ApplyAndAdvance(-1); Key:=0; end else
  // Cursor runter = Beschreibung bernehmen, Cursor nach unten
  if Key=VK_DOWN then begin ApplyAndAdvance(+1); Key:=0; end;
end;

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////// Bilderlisten-Men
////////////////////////////////////////////////////////////////////////////////

///// BImageMenu.OnClick: Bilderlisten-Men-Popup anzeigen
procedure TMainForm.BImageMenuClick(Sender: TObject);
var Point:TPoint;
begin
  Point:=BImageMenu.ClientToScreen(Classes.Point(0,BImageMenu.Height));
  ImageMenu.Popup(Point.X,Point.Y);
end;


///// MShowPreview.OnClick: Preview des ausgewhlten Bildes anzeigen
///// Trick 17b ist mal wieder, da im Tag des jeweiligen Menpunkts vermerkt
///// ist, ob das Vorschaubild oder das Thumbnail angezeigt werden soll
procedure TMainForm.MShowPreviewClick(Sender: TObject);
var BoxIndex,Index:integer;
    Raw,Scaled,Compressed:TBitmap;
    Size:integer;
    ImageType:TImageType;
    T1,T2:cardinal;
    VirtualName:string;
begin
  // BoxIndex lesen
  BoxIndex:=CImages.ItemIndex;
  if BoxIndex<0 then exit;
  ImageType:=TImageType((Sender as TComponent).Tag);  // Preview/Thumbnail
  Data.Renum;  // Zielnummerierung vornehmen
  Index:=s2i(CImages.Items[BoxIndex]);  // Zielindex ermitteln
  // Bild komplett berechnen, dabei Zeit nehmen
  T1:=GetTickCount();
  Raw:=PreprocessImage(Data[Index]^);
  if not Assigned(Raw) then exit;
  Scaled:=ScaleImage(Data[Index]^,Raw,ImageType);
  Raw.Free;
  if not Assigned(Scaled) then exit;
  Compressed:=TestCompressImage(Scaled,ImageType,Size);
  Scaled.Free;
  T2:=GetTickCount();
  if not Assigned(Compressed) then exit;
  // Zieldateiname konstruieren
  if ImageType=itPreview
    then VirtualName:=BuildFileName(Data[Index]^.Number,EfnPreview.Text)
    else VirtualName:=BuildFileName(Data[Index]^.Number,EfnThumbnails.Text);
  // Preview-Fenster anzeigen
  PreviewForm.Show(Compressed,VirtualName+'.jpg ('+IntToStr(Size)+' Bytes, '+
    IntToStr(Compressed.Width)+'x'+IntToStr(Compressed.Height)+', '+
    FormatFloat('0.00',(T2-T1)*0.001)+'s)');
  Compressed.Free;
end;


///// ImageMenu.MSortBy*.OnClick: Bilder der aktuellen Kategorie sortieren
///// (die Hauptarbeit macht Data.SortImages(), also sind die Funktionen
///// von der Implementation her quivalent)
procedure TMainForm.MSortByNameClick(Sender: TObject);
begin
  Data.SortImages(CompareByName);
  Data.Rehash;
  CCategoryChange(nil);
end;
procedure TMainForm.MSortByDateClick(Sender: TObject);
begin
  Data.SortImages(CompareByFileDate);
  Data.Rehash;
  CCategoryChange(nil);
end;
procedure TMainForm.MSortByEXIFClick(Sender: TObject);
begin
  Data.SortImages(CompareByEXIFDate);
  Data.Rehash;
  CCategoryChange(nil);
end;


///// MReset.OnClick: nach Besttigung Bilderliste komplett lschen
procedure TMainForm.MResetClick(Sender: TObject);
begin
  // Besttigung einholen
  if MessageDlg('Soll die Bilderliste wirklich komplett geleert werden?',
                mtConfirmation,[mbYes,mbNo],0)<>mrYes then exit;
  // die einfachste Methode eines Reset: Bilderliste freigeben und neu anlegen
  Data.Free;
  Data:=TImageManager.Create;
  // alles aktualisieren
  Data.CategoriesToStrings(-1,CCategory.Items);
  CCategory.ItemIndex:=0;
  CCategoryChange(nil);
end;


///// MAddImages.OnClick: Dateien auswhlen und hinzufgen
procedure TMainForm.MAddImagesClick(Sender: TObject);
begin
  if DAddImages.Execute then
    AddFileList(DAddImages.Files);
end;


////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////// Kategorieneditor
////////////////////////////////////////////////////////////////////////////////

///// BEditCategories.OnClick: Kategorieneditor ffnen
procedure TMainForm.BEditCategoriesClick(Sender: TObject);
begin
  // zunchst den Rest der Bilderlistenseite unfunktionell machen, um Seiten-
  // effekte zu vermeiden
  CImages.Enabled:=false;
  BImageMenu.Enabled:=false;
  EComment.Enabled:=false;
  BImageUp.Enabled:=false;
  BImageDown.Enabled:=false;
  // Kategorienliste im Editor aktualisieren und Kategorieneditor anzeigen
  Data.CategoriesToStrings(1,CatList.Items);
  CategoriesChanged:=false;
  PCatEdit.Visible:=true;
end;


///// BCatClose.OnClick: nderungen bernehmen und Kategorieneditor schlieen
procedure TMainForm.BCatCloseClick(Sender: TObject);
begin
  PCatEdit.Visible:=false;
  // wenn nderungen vorgenommen wurden, diese in den Bilderlisten-Controls
  // aktualisieren
  if CategoriesChanged then begin
    Data.CategoriesToStrings(-1,CCategory.Items);
    Data.Rehash;
    CCategory.ItemIndex:=CatList.ItemIndex+2;
    CCategoryChange(nil);
  end;
  // Bilderlisten-Controls wieder funktionell machen
  CImages.Enabled:=true;
  BImageMenu.Enabled:=true;
  EComment.Enabled:=true;
  BImageUp.Enabled:=true;
  BImageDown.Enabled:=true;
end;


///// BCatUp.OnClick: Kategorie nach oben verschieben
procedure TMainForm.BCatUpClick(Sender: TObject);
var OldIndex:integer;
begin
  OldIndex:=CatList.ItemIndex;
  if not Data.ExchangeCategory(OldIndex+1,OldIndex) then exit;
  CategoriesChanged:=true;
  Data.CategoriesToStrings(1,CatList.Items);
  CatList.ItemIndex:=OldIndex-1;
end;


///// BCatDown.OnClick: Kategorie nach unten verschieben
procedure TMainForm.BCatDownClick(Sender: TObject);
var OldIndex:integer;
begin
  OldIndex:=CatList.ItemIndex;
  if not Data.ExchangeCategory(OldIndex+1,OldIndex+2) then exit;
  CategoriesChanged:=true;
  Data.CategoriesToStrings(1,CatList.Items);
  CatList.ItemIndex:=OldIndex+1;
end;


///// BCatRename.OnClick: Zur Eingabe eines neuen Kategoriennamens auffordern
///// und Kategorie entsprechend umbenennen
procedure TMainForm.BCatRenameClick(Sender: TObject);
var OldIndex:integer;
begin
  OldIndex:=CatList.ItemIndex;
  if OldIndex<0 then exit;
  // Eingabeaufforderung
  Data.Categories[OldIndex+1]:=InputBox('Kategorienname ndern',
    'Neuer Name fr die Kategorie '#187+Data.Categories[OldIndex+1]+#171':',
    Data.Categories[OldIndex+1]);
  // Aktualisierung 
  CategoriesChanged:=true;
  Data.CategoriesToStrings(1,CatList.Items);
  CatList.ItemIndex:=OldIndex;
end;


///// BCatRemove.OnClick: Kategorie nach einer Besttigung lschen
procedure TMainForm.BCatRemoveClick(Sender: TObject);
var OldIndex:integer;
begin
  OldIndex:=CatList.ItemIndex;
  if OldIndex<0 then exit;
  // Besttigung anzeigen
  if MessageDlg('Kategorie '#187+Data.Categories[OldIndex+1]+
    #171' wirklich lschen?'^M^M'Bilder, die dieser Kategorie angehren,'^M+
    'werden als nicht zugewiesen markiert!',
    mtConfirmation,[mbYes,mbNo],0)<>mrYes then exit;
  // Kategorie lschen (lassen)
  if not Data.RemoveCategory(OldIndex+1) then exit;
  // Aktualisierung
  CategoriesChanged:=true;
  Data.CategoriesToStrings(1,CatList.Items);
  CatList.ItemIndex:=OldIndex;
end;


///// BCatAdd.OnClick: Kategorienname eingeben und Kategorie anlegen
procedure TMainForm.BCatAddClick(Sender: TObject);
var CatName:string;
begin
  // Eingabeaufforderung
  CatName:=InputBox('Kategorie hinzufgen','Name fr die neue Kategorie:','');
  if CatName='' then exit;
  // Hinzufgen der Kategorie
  Data.AddCategory(CatName);
  // Aktualiserung
  CategoriesChanged:=true;
  Data.CategoriesToStrings(1,CatList.Items);
  CatList.ItemIndex:=Data.CategoryCount-1;
end;


////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////// Dateioperationen
////////////////////////////////////////////////////////////////////////////////

///// MainForm.OnShow/OnHide: Drag&Drop aktivieren/deaktivieren
procedure TMainForm.FormShow(Sender: TObject);
begin
  DragAcceptFiles(Handle,true);
end;
procedure TMainForm.FormHide(Sender: TObject);
begin
  DragAcceptFiles(Handle,false);
end;


///// MainForm'WM_DROPFILES: Drag&Drop-Handler
procedure TMainForm.FormDropFiles(var msg:TMessage);
var hDrop:THandle;
    Count,Total:integer;
    FileName:array[0..MAX_PATH+1]of char;
    FileList:TStringList;
begin
  // Drop-Handle bestimmen, abgelegte Dateien zhlen
  hDrop:=msg.WParam;
  Total:=DragQueryFile(hDrop,cardinal(-1),nil,0);
  // bei nur einer Datei prfen, ob ihr Name ein existierendes Verzeichnis ist
  // und dieses ggf. als Zielverzeichnis bernehmen
  if Total=1 then begin
    DragQueryFile(hDrop,0,@FileName[0],MAX_PATH);
    if DirectoryExists(FileName) then begin
      EDestDir.Text:=FileName;
      Log('+Neues Zielverzeichnis: '+FileName);
      exit;
    end;
  end;
  // Dateiliste erstellen und mit den gedroppten Files fllen
  FileList:=TStringList.Create;
  for Count:=0 to (Total-1) do begin
    DragQueryFile(hDrop,Count,@FileName[0],MAX_PATH);
    FileList.Add(FileName);
  end;
  // schlielich Drop-Handle freigeben und Dateiliste zur Bilderliste hinzufgen
  DragFinish(hDrop);
  AddFileList(FileList);
  FileList.Free;
end;


///// AddFileList: fgt alle Dateien aus einer TStrings-Liste zu der Bilderliste
///// hinzu
procedure TMainForm.AddFileList(FileList:TStrings);
var Total,Count,Success,Errors:integer;
    FileName:string;
begin
  // Dateien zhlen, fr lngere Operation auf PLog umschalten, Status loggen
  Total:=FileList.Count;
  SelectOp(nil);
  Log('');
  Log('/Fge '+IntToStr(Total)+' Dateien hinzu');
  Data.UnselectAll;  // Markierung in Data[] lschen, da neue Dateien
                     // anschlieend markiert werden sollen
  Success:=0; Errors:=0;
  // Dateien hinzufgen:
  for Count:=0 to (Total-1) do begin
    // Dateiname expandieren, da Data[].PathName pfadunabhngig sein mu
    FileName:=ExpandUNCFileName(FileList[Count]);
    // doppelte Dateien verhindern (Data[].PathName mu eindeutig sein)
    if Data.FindImage(FileName)>=0 then
      Log('_['+IntToStr(Count+1)+'/'+IntToStr(Total)+'] Bereits in der Liste: '+FileName)
    else
      // Bild hinzuzufgen versuchen
      if AcquireImage(FileName) then begin
        // Erfolg
        Log('*['+IntToStr(Count+1)+'/'+IntToStr(Total)+'] Bild hinzugefgt: '+FileName);
        inc(Success);
      end else if AI_Unknown_File_Type then
        // Datei heit nicht BMP, JPG oder JPEG
        Log('_['+IntToStr(Count+1)+'/'+IntToStr(Total)+'] Unbekannter Dateityp: '+FileName)
      else begin
        // Datei konnte nicht eingelesen werden
        Log('-['+IntToStr(Count+1)+'/'+IntToStr(Total)+'] Fehler beim Hinzufgen: '+FileName);
        inc(Errors);
      end;
    // Benutzerinteraktion zulassen, ggf. abbrechen
    Application.ProcessMessages;
    if AbortOp then break;
  end;
  // Status loggen
  if AbortOp then Log('-Vorgang vom Benutzer abgebrochen');
  Log('+'+IntToStr(Success)+' von '+IntToStr(Total)+
      ' Dateien erfolgreich hinzugefgt, '+IntToStr(Errors)+' Fehler');
  Log('');
  // Daten neu sortieren, Bilderlisten-Controls auffrischen
  Data.Rehash;
  CCategoryChange(nil);
  ApplySelection;
  // ggf. zur Bilderliste zurckschalten
  if AbortOp then
    SelectOp(PLog)
  else begin
    Sleep(500);  // 1/2 Sekunde Zeit fr den User, den Status zu lesen
    SelectOp(PImages);
  end;
end;


////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////// Logbuch und Operation-Locks
////////////////////////////////////////////////////////////////////////////////

///// Log: eine Zeile zum Logbuch hinzufgen
///// aufeinanderfolgende leere Zeilen ('') werden nur 1x wiederholt
///// jede Zeile hat als erstes Zeichen einen Code fr die Farbe (s.u.)
var LastLogEntryWasASpace:boolean;  // letzte Logbuchzeile = Leerzeile?
procedure Log(const msg:string);
begin
  if (msg='') AND LastLogEntryWasASpace then exit;
  with MainForm.LogBox do begin
    Items.Add(msg);
    ItemIndex:=Items.Count-1;
    if Visible then Repaint;
  end;
  LastLogEntryWasASpace:=(msg='');
end;


///// LogBox.OnDrawItem: zeichnet eine Zeile aus der LogBox
///// das erste Zeichen entscheidet ber die Farbe des Eintrags:
/////   grn  '+' (OK)         'G' (grn)
/////   rot   '-' (Fehler)     'R' (rot)        'E' (Error)  '!' (Warnung)
/////   blau  '/' (Meldung)    'B' (blau)
/////   grau  '_' (unwichtig)  '0' (unwichtig)
///// sonst schwarz
procedure TMainForm.LogBoxDrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
var s:string;
begin with LogBox.Canvas do begin
  Brush.Color:=clWindow;  // keine Markierung anzeigen
  FillRect(Rect);
  s:=LogBox.Items[Index];
  if s='' then exit;
  // Farbe aussuchen
  case s[1] of
    '+','G':Font.Color:=clGreen;
    '-','R','E','!':Font.Color:=clRed;
    '/','B':Font.Color:=clBlue;
    '_','0':Font.Color:=clGray;
  else
    Font.Color:=clWindowText;
  end;
  // Zeile ausgeben
  TextOut(Rect.Left+2,Rect.Top,copy(s,2,length(s)-1));
end; end;


///// SelectOp: lngerfristige Operation einberufen oder beenden:
/////   ReturnToTab=nil -> Operation starten, OpLock ein, PLog aktivieren
/////   ansonsten -> Operation beendet, OpLock aus, gegebenes Tab aktivieren
procedure TMainForm.SelectOp(ReturnToTab:TTabSheet);
begin
  if not Assigned(ReturnToTab) then begin
    AbortOp:=false;
    BAbortOp.Enabled:=true;
    PageThing.ActivePage:=PLog;
    OpLock:=true;
  end else begin
    OpLock:=false;
    BAbortOp.Enabled:=false;
    if ReturnToTab<>PLog then PageThing.ActivePage:=ReturnToTab;
  end;
end;


///// BAbortOp.OnClick: AbortOp setzen
procedure TMainForm.BAbortOpClick(Sender: TObject);
begin
  AbortOp:=true;
end;


///// PageThing.OnChanging: Wechsel von Seiten nicht zulassen, wenn OpLock
///// aktiv
procedure TMainForm.PageThingChanging(Sender: TObject;
  var AllowChange: Boolean);
begin
  AllowChange:=not(OpLock);
end;


////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////// Einstellungen
////////////////////////////////////////////////////////////////////////////////

///// C[PT]Quadratic.OnClick: [EC][PT]SizeY enabled/disabled stellen
procedure TMainForm.CPQuadraticClick(Sender: TObject);
begin
  EPSizeY.Enabled:=not(CPQuadratic.Checked);
  CPSizeY.Enabled:=not(CPQuadratic.Checked);
  LPSizeX.Enabled:=not(CPQuadratic.Checked);
  CPSizeXClick(nil,btNext);
end;
procedure TMainForm.CTQuadraticClick(Sender: TObject);
begin
  ETSizeY.Enabled:=not(CTQuadratic.Checked);
  CTSizeY.Enabled:=not(CTQuadratic.Checked);
  LTSizeX.Enabled:=not(CTQuadratic.Checked);
  CTSizeXClick(nil,btNext);
end;


///// C[PT]SizeX.OnClick: C[PT]SizeY mitndern, wenn C[PT]Quadratic aktiv
procedure TMainForm.CPSizeXClick(Sender: TObject; Button: TUDBtnType);
begin
  if CPQuadratic.Checked then CPSizeY.Position:=CPSizeX.Position;
end;
procedure TMainForm.CTSizeXClick(Sender: TObject; Button: TUDBtnType);
begin
  if CTQuadratic.Checked then CTSizeY.Position:=CTSizeX.Position;
end;


///// BDestDir.OnClick: Dialog zur Zielverzeichnisauswahl aufrufen
procedure TMainForm.BDestDirClick(Sender: TObject);
begin
  DestDirDialog.InitialDir:=EDestDir.Text;
  if DestDirDialog.Execute then
    EDestDir.Text:=ExcludeTrailingPathDelimiter(
                   ExtractFilePath(DestDirDialog.FileName));
end;


///// Cdir(Preview|Thumbnails).OnClick: Edir(Preview|Thumbnails).Enabled setzen
procedure TMainForm.CdirPreviewClick(Sender: TObject);
begin
  EdirPreview.Enabled:=CdirPreview.Checked;
end;
procedure TMainForm.CdirThumbnailsClick(Sender: TObject);
begin
  EdirThumbnails.Enabled:=CdirThumbnails.Checked;
end;


///// COutputHTML.OnChange: [LEC]ThumbsPerLine.Enabled, wenn Index erwnscht
procedure TMainForm.COutputHTMLChange(Sender: TObject);
var x:boolean;
begin
  x:=(COutputHTML.ItemIndex>1);
  LThumbsPerLine.Enabled:=x;
  EThumbsPerLine.Enabled:=x;
  CThumbsPerLine.Enabled:=x;
end;


///// CEnableFrame.OnClick: [EC]FrameSize.Enabled setzen
procedure TMainForm.CEnableFrameClick(Sender: TObject);
begin
  EFrameSize.Enabled:=CEnableFrame.Checked;
  CFrameSize.Enabled:=CEnableFrame.Checked;
end;


///// CEnableEqualize.OnClick: [LEC]Equalize(Strength|Gray|RGB).Enabled setzen
procedure TMainForm.CEnableEqualizeClick(Sender: TObject);
var x:boolean;
begin
  x:=CEnableEqualize.Checked;
  EEqualizeStrength.Enabled:=x;
  CEqualizeStrength.Enabled:=x;
  LEqualizeStrength.Enabled:=x;
  CEqualizeGray.Enabled:=x;
  CEqualizeRGB.Enabled:=x;
end;


///// B(Load|Save)Project.OnClick: Speicher-/Ladedialog anzeigen und Projekt
///// speichern bzw. laden
procedure TMainForm.BSaveProjectClick(Sender: TObject);
begin
  if DSaveProject.Execute then
    SaveProject(DSaveProject.FileName);
end;
procedure TMainForm.BLoadProjectClick(Sender: TObject);
begin
  if DLoadProject.Execute then
    LoadProject(DLoadProject.FileName);
end;

///// BGo.OnClick: Album erzeugen lassen
procedure TMainForm.BGoClick(Sender: TObject);
begin
  Process.DoIt;
end;

end.
